SystemOrganization addCategory: #'Cache-Scripting-Experiments'!

Object subclass: #CacheSet
	instanceVariableNames: 'set'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

CacheSet subclass: #AnalysisInformallyAnotatedCaches
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 17:02'!
cachesForClass: aClass

	^ aClass instanceVariables ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]
! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:25'!
cachesForClassInClassVars: aClass

	^ aClass classVarNames ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]
! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:26'!
cachesForMethod: aMethod

	^ aMethod tempNames ifNil: [ {  } ] ifNotNilDo: 
		[:temps | (temps select: [ :temp | temp includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:32'!
checkForClassVarsIn: class

	class isMeta ifFalse: [
				(self cachesForClassInClassVars: class)
					ifNotEmptyDo: [:caches | 
							caches do: [ :cache | set add: (SharedCachingVariable new class: class  name: cache ) ]]
			]! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:32'!
checkForIVsIn: class

	(self cachesForClass: class) ifNotEmptyDo: [:caches | 
		caches do: [ :cache |
				|cachingVar| 
				class isMeta
					ifTrue: [ cachingVar := ClassSideCachingVariable new class: class name: cache  ]
					ifFalse: [ cachingVar := InstanceSideCachingVariable new class: class name: cache  ]. 
					set add: cachingVar ]].! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:33'!
checkForTempsIn: class

	class methods do: [ :method |
				(self cachesForMethod: method) 
					ifNotEmptyDo: [:caches | 
						caches do: [ :cache | set add: (TempCachingVariable new class: method methodClass name: cache method: method ) ]]
				]! !

!AnalysisInformallyAnotatedCaches methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 17:37'!
gatherSet

	ProtoObject allSubclasses do: [ :class |
		class package ~= self class package ifTrue: [   
			self checkForIVsIn: class. "both instance side and class side for metaclasses"
			self checkForClassVarsIn: class.
			self checkForTempsIn: class.
		]
	].
	! !

!CacheSet methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:13'!
exportToFuel

	FLSerializer serialize: set toFileNamed: self class name , '-' , DateAndTime now asString.! !

!CacheSet methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:02'!
gatherSet

	self subclassResponsibility ! !

!CacheSet methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 19:09'!
initialize

	set := Set new! !

!CacheSet methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 18:01'!
postProcessing

	set do: [ :cachingVariable | cachingVariable postProcessing ]! !

!CacheSet methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 19:09'!
set

	^ set! !

CacheSet subclass: #CaseStudySystemWide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

CacheSet subclass: #ValidationGlobalStateCaches
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

Object subclass: #CachingVariable
	instanceVariableNames: 'packageGroup package class name methods testClass values selectors protocols patterns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 19:54'!
= anObject

	^ ((self class = anObject class) and: [ class = anObject cacheClass ]) and: [ name = anObject name ]! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/20/2015 17:36'!
cacheClass
	^ class! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/21/2015 11:46'!
class: aClass name: aName

	name := aName asSymbol. "just to be sure"
	class := aClass name asSymbol.
	package := aClass package name asSymbol.
	packageGroup := (package asString findTokens: '-') first asSymbol.
	! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 19:50'!
hash

	^ (self class hash bitXor: class hash) bitXor: name hash! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 19:19'!
liveMethods

	^ methods collect: [ :method | |tokens|
		tokens := method asString findTokens: '>>#'.
		(Smalltalk globals at: tokens first asSymbol) >> tokens last asSymbol]! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/20/2015 17:36'!
methods
	^ methods! !

!CachingVariable methodsFor: 'accessing' stamp: 'NickPapoulias 10/20/2015 17:37'!
name
	^ name! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 18:20'!
postProcessing

	"calculate values, selectors and patterns"
	self postProcessingTestClass.
	self postProcessingMethods.
	self postProcessingValues.
	self postProcessingSelectors.
	self postProcessingProtocols. "less concrete in static analysis"
	self postProcessingPatterns.! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 19:01'!
postProcessingMethods

	"calculate values, selectors and patterns"
	methods := ((Smalltalk globals at: class) methods 
						select: [:method | 
							(method variableNodes select: [ :node | node name = name ]) isEmpty not ])
						collect: [ :method | method printString asSymbol ]
	! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 18:29'!
postProcessingPatterns
! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 18:48'!
postProcessingProtocols

	protocols := selectors flatCollect: [:selector | 
		(SystemNavigation default allImplementorsOf: selector) 
			collect: [ :rgMethod | rgMethod protocol ]  ]! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 19:13'!
postProcessingSelectors

	|nodes|

	nodes := ((self liveMethods collect: [:method | method variableNodes ])
		select: [ :node | node variable name = name ])
		collect: [ :node | node parent isMessage].
		
	selectors := nodes collect: [ :node | node parent selector ].
	! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 15:50'!
postProcessingTestClass

	|lookFor|

	lookFor := (class asString , 'Test') asSymbol.
	(Smalltalk globals keys includes: lookFor)
		ifTrue: [ testClass := lookFor ]! !

!CachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 19:04'!
postProcessingValues

	|nodes|

	nodes := ((self liveMethods collect: [:method | method assignmentNodes ])
		select: [ :assignNode | assignNode variable name = name ])
		collect: [ :assignNode | assignNode value].
		
	values := (nodes select: [ values isLiteralNode ]) collect: [ :node | node value ].
	values addAll: (nodes select: [ values isMessage ]) select: [ :node | node receiver isLiteral and: [ node receiver value isClass ] and: [node selector = #new] ].! !

CachingVariable subclass: #ClassSideCachingVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

CachingVariable subclass: #InstanceSideCachingVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

CachingVariable subclass: #SharedCachingVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!SharedCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 16:14'!
postProcessingMethods

	super postProcessingMethods.
	methods ifNil: [ methods := OrderedCollection new ].
	methods addAll: ((class class methods "class side"
						select: [:method | 
							(method variableNodes select: [ :node | node name = name ]) isEmpty not ])
						collect: [ :method | method printString asSymbol ]).! !

CachingVariable subclass: #TempCachingVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 19:55'!
= anObject

	^ (super = anObject) and: [ methods = anObject methods ]! !

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 18:58'!
class: aClass name: aName method: aMethod

	super class: aClass name: aName.
	methods := OrderedCollection new add: aMethod printString asSymbol; yourself! !

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/20/2015 19:56'!
hash

	^ super hash bitXor: methods first hash! !

!TempCachingVariable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 15:58'!
postProcessingMethods
	
	"nothing to do only one method accesses me"! !

Object subclass: #ImageInfo
	instanceVariableNames: 'version packagesToNumberOfClasses packageGroupsToNumberOfClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Scripting-Experiments'!

!ImageInfo methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/21/2015 12:01'!
initialize

	version := SystemVersion current asString.
	packagesToNumberOfClasses := (ProtoObject allSubclasses 
		collect: [ :class | class package name asSymbol -> class package classes size ]) asDictionary.
	packageGroupsToNumberOfClasses := Dictionary new.
	packagesToNumberOfClasses keysAndValues
		do: [ :package :numberOfClasses | 
			|before packageGroup|
			packageGroup := (package asString findToken: '-') first asSymbol.
			before := (packageGroupsToNumberOfClasses 
				at: packageGroup
				ifAbsentPut: 0).
			packageGroupsToNumberOfClasses 
				at: packageGroup
			  	put: before + numberOfClasses.
		].! !
